<template>
  <div>
    <VRow justify="space-between">
      <VCol cols="12" md="6" lg="5">
        <div class="text-h4">Дымоходы/Вентканалы (Д/В)</div>
      </VCol>
      <OutagesFilters @filter-updated="updateFilter" :region="regions" />
    </VRow>
    
    <PlaceholderPage
      v-if="filterEmpty || pending"
      :text="placeholderText"
    />

    <template v-else>
      <div class="outages__top top-outages_five">
        <div v-for="(card, i) in cardStats" :key="i" class="top-outages__item">
          <div v-if="card.head" class="unit__head">{{ card.head }}</div>
          <div
            :class="['d-flex flex justify-space-between unit unit--stats', {
              'align-end': card.alignEnd,
            }]"
          >
            <div class="unit__col">
              <div class="unit__title">{{ card.left.caption }}</div>
              <div class="unit__value text-h5 font-weight-semibold">{{ card.left.value }}</div>
              <div v-if="card.left.bottom" class="unit__value text-h5 font-weight-semibold">{{ card.left.bottom }}</div>
            </div>
            <div
              :class="['unit__col unit__col--right', {
                'justify-space-between fill-height': card.right.fillHeight,
              }]"
            >
              <div class="unit__title">{{ card.right.caption }}</div>
              <div
                :class="['unit__value text-h5 font-weight-semibold', {
                  'unit__value--end': card.alignEnd, 'unit_tar': card.right }]">
                {{ card.right.value }}
              </div>
              <div v-if="card.right.bottom" class="unit__value text-h5 font-weight-semibold">{{ card.right.bottom }}</div>
            </div>
          </div>
        </div>
      </div>
      <div class="grid-ventilation">
        <div class="grid-ventilation__item item-gridVentilation">
          <div class="item-gridVentilation__head unit">
            Аварийные отключения
          </div>
          <div class="item-gridVentilation__body">
            <div class="grid-outages__item">
              <div
              class="flex-grow-1"
              :class="$style.unit"
              >
                <VentilationDiagram
                  title="Отключено газоснабжение"
                  subTitle="(на текущую дату) МКД"
                  :meaning="diagramDataOne"
                  :theme-mode="themeMode"
                />
              </div>
            </div>
            <div class="grid-outages__item">
              <div
              class="flex-grow-1"
              :class="$style.unit"
              >
                <VentilationDiagram
                  title="Восстановлено газоснабжение"
                  subTitle="(за отчётный период) МКД"
                  :meaning="diagramDataTwo"
                  :theme-mode="themeMode"
                />
              </div>
            </div>
          </div>
        </div>
        <div class="grid-ventilation__item item-gridVentilation">
          <div class="item-gridVentilation__head unit">
            Плановые работы
          </div>
          <div class="item-gridVentilation__body">
            <div class="grid-outages__item">
              <div class="flex-grow-1" :class="$style.unit">
                <Speedometer
                  title="Обследование тех.состояния Д/В в МКД"
                  subTitle="(на текущую дату)"
                  titleMaxWidth="100%"
                  :meaning="speedometer"
                />
              </div>
            </div>
            <div class="grid-outages__item">
              <div class="flex-grow-1" :class="$style.unit">
                <VentilationBarChart
                  title="Обследование тех.состояния Д/В в МКД"
                  subTitle="(на текущую дату)"
                  titleMaxWidth="100%"
                  :meaning="bar"
                />
              </div>
            </div>
          </div>
        </div>
        <div class="grid-ventilation__item item-gridVentilation item-gridVentilation_big">
          <div
            class="item-gridVentilation__head unit"
            v-if="filter.region === undefined || filter.region === null"
          >
            Отключено газоснабжение в МКД по МР и ГО РБ
          </div>
          <div class="item-gridVentilation__body">
            <VueCustomScrollbar
              v-if="filter.region === undefined || filter.region === null"
              :class="$style.wrapper"
              :settings="scrollbarSettings"
            >
              <VDataTable
                fixed-header
                hide-default-footer
                :headers="table.headers"
                :items="table.items"
                class="custom-table transparent"
                :class="$style.gridOutagesTable"
                :items-per-page="-1"
              >
                <template #body="{ items }">
                  <tbody>
                  <tr v-for="(item, index) in items" :key="index">
                    <td>{{ item.name }}</td>
                    <td>{{ item.count }}</td>
                  </tr>
                  </tbody>
                </template>
              </VDataTable>
            </VueCustomScrollbar>
  
            <div
              v-else
              class="grid-outages__item grid-outages__item_map"
              :class="$style.gridOutagesMap"
            >
              <div class="unit flex-grow-1">
                <OverhaulMap :theme-mode="themeMode" :mapData="mapData" />
              </div>
            </div>
          </div>
        </div>
      </div>
    </template>

  </div>
</template>

<script>
import { VCol, VRow } from "vuetify/lib";
import OverhaulMap from "@/components/Overhaul/OverhaulMap";
import OutagesFilters from "@/components/Outages/OutagesFilters";
import VentilationDiagram from "@/components/Ventilation/VentilationDiagram";
import Speedometer from "@/components/Ventilation/Speedometer";
import VentilationBarChart from "@/components/Ventilation/VentilationBarChart";
import { convertIntegerToText } from "@/constants/helpers";
import VueCustomScrollbar from "vue-custom-scrollbar";
import { scrollbarSettings } from "@/constants/scrollbar";
import PlaceholderPage from "@/components/Overhaul/PlaceholderPage";

export default {
  name: 'OverhaulIndex',
  components: {
    VRow,
    VCol,
    OutagesFilters,
    OverhaulMap,
    VentilationDiagram,
    VueCustomScrollbar,
    PlaceholderPage,
    Speedometer,
    VentilationBarChart
  },
  apollo: {
    getAddrObj: {
      query: require('@/graphql/getAddrObj.gql'),
      result(response) {
        const regions = response.data?.getAddrObj?.nextAddrObjs || [];
        this.regions = [
          {
            fullName: 'Республика Башкортостан',
            objectId: undefined,
          },
          ...regions,
        ];
        this.tableItemsForm();
      }
    },
    // getRegionsGasShutdown: {
    //   query: require('@/graphql/getRegionsGasShutdown.gql'),
    //   variables() {
    //     return {
    //       periodStart: this.filter.period?.[0]?.toString(),
    //       periodEnd: this.filter.period?.[1]?.toString(),
    //       orderBy: 'district',
    //       orderWay: 'asc'
    //     }
    //   },
    //   skip() {
    //     return !this.isFilterCompleted;
    //   },
    //   result(response) {
    //     console.log(response);
    //   },
    // },

    getVentilationDashboard: {
      query: require('@/graphql/getVentilationDashboard.gql'),
      variables() {
        return {
          periodStart: this.filter.period?.[0]?.toString(),
          periodEnd: this.filter.period?.[1]?.toString(),
          districtGarId: this.filter.region
        }
      },
      skip() {
        return this.filter.period?.length < 2;
      },
      result(response) {
        console.log(response);
      },
    },
  },
  data() {
    return {
      hardCodeData: {
        periodStart: null,
        periodEnd: null,
        totalWithGasEquipment: {
          mkd: 12806,
          kv: 631366,
        },
        shutdownTotal: {
          mkd: 463,
          kv: 8201,
        },
        shutdownWithGP: {
          mkd: 263,
          kv: 4201,
        },
        shutdownWithGpGv: {
          mkd: 163,
          kv: 1201,
        },
        shutdownWithGpGk: {
          mkd: 63,
          kv: 801,
        },
      },
      bar: {
        sideTexts: [
          {
            title: 'Осмечено',
            value: 10000,
            color: '#42b983'
          },
          {
            title: 'Требуют осмечивания',
            value: 6000,
            color: '#d63200'
          },
        ],
        data: {
          series: [{
            name: 'Осмечено',
            data: [0, 10000, 0]
          }, {
            name: 'Требуют осмечивания',
            data: [0, 6000, 0]
          },],
          total: [0, 16000, 0],
          labels: []
        },
        colors: ['#00a759', '#d63200'],
      },
      speedometer: {
        colors: ["tomato", "gold", "limegreen"],
        value: 10000,
        maxValue: 12806,
        needleColor: this.$vuetify.theme.dark ? '#ccc' : '#000',
        textColor: this.$vuetify.theme.dark ? '#ccc' : '#000',
      },
      regions: [
        {
          fullName: 'Республика Башкортостан',
          objectId: undefined
        }
      ],
      diagramDataOne: {
        sideTexts: [
          {
            title: 'МКД оборудованные только газовыми плитами',
            value: 263,
            color: '#42b983'
          },
          {
            title: 'Не проверенные по Ф20 Газ Рабочие',
            value: 163,
            color: '#486491'
          },
          {
            title: 'Аварийные',
            value: 63,
            color: '#d63200'
          },
        ],
        data: {
          series: [263, 163, 63],
          labels: ['','',''],
        },
        colors: ['#00a759', '#0093cb', '#fc2626'],
      },
      diagramDataTwo: {
        sideTexts: [
          {
            title: '0 - 21% хорошее состояние',
            value: 20,
            color: '#42b983'
          },
          {
            title: '21 - 40% удовлетворительное состояние',
            value: 6,
            color: '#486491'
          },
          {
            title: '41 - 60% не удовлетворительное состояние',
            value: 4,
            color: '#d63200'
          },
        ],
        data: {
          series: [20, 6, 4],
          labels: [
            '',
            '',
            '',
          ]
        },
        colors: ['#00a759', '#0093cb', '#fc2626', '#fca326'],
      },
      filter: {
        period: [],
        region: undefined,
      },
      mapData: {
        typename: 'VentilationDashboard',
        items: [
          {
            coord: [54.74728667873139, 55.9947550905636],
            title: 'Достоевского ул., д.83',
            greentext: {
              left: 'Дата отключения подачи газа',
              right: '28.06.2022'
            },
            rows: [
              {
                black: 'Способ управления МКД',
                grey: 'УК ООО "Управляющая компания"'
              },
              {
                black: 'Затраты на восстановление',
                grey: '0000000 руб.'
              },
              {
                black: 'Источник финансирования',
                grey: 'Бюджет МО'
              },
              {
                black: 'Причина отключения',
                grey: 'Заключение проверки работоспособности дымохода - нет тяги.'
              },
            ]
          }
        ]
      },
      table: {
        headers: [
          { text: "Наименование муниципального района", value: "id", class: "text-uppercase" },
          { text: "Отключено МКД", value: "address", class: "text-uppercase" },
        ],
        items: [],
      },
    }
  },
  computed: {
    themeMode() {
      return this.$vuetify.theme.dark ? 'dark' : 'light';
    },
    pending() {
      return this.$apollo.queries.getVentilationDashboard.loading;
    },
    filterEmpty() {
      return this.filter.period?.length < 2;
    },
    placeholderText() {
      return this.pending ? 'Загружаем данные' : 'Выберите период и регион для отображения данных'
    },
    cardStats() {
      return [
        {
          head: 'Всего с газовым оборудованием',
          left: { caption: 'МКД', value: convertIntegerToText(this.hardCodeData.totalWithGasEquipment.mkd) },
          right: { caption: 'КВ', value: convertIntegerToText(this.hardCodeData.totalWithGasEquipment.kv) },
        },
        {
          head: 'Отключено газоснабжение ВСЕГО',
          left: { caption: 'МКД', value: convertIntegerToText(this.hardCodeData.shutdownTotal.mkd) },
          right: { caption: 'КВ', value: convertIntegerToText(this.hardCodeData.shutdownTotal.kv) },
        },
        {
          head: 'Отключено газоснабжение с ГП',
          left: { caption: 'МКД', value: convertIntegerToText(this.hardCodeData.shutdownWithGP.mkd) },
          right: { caption: 'КВ', value: convertIntegerToText(this.hardCodeData.shutdownWithGP.kv) },
        },
        {
          head: 'Отключено газоснабжение с ГП/ГВ',
          left: { caption: 'МКД', value: convertIntegerToText(this.hardCodeData.shutdownWithGpGv.mkd) },
          right: { caption: 'КВ', value: convertIntegerToText(this.hardCodeData.shutdownWithGpGv.kv) },
        },
        {
          head: 'Отключено газоснабжение с ГП/ГК',
          left: { caption: 'МКД', value: convertIntegerToText(this.hardCodeData.shutdownWithGpGk.mkd) },
          right: { caption: 'КВ', value: convertIntegerToText(this.hardCodeData.shutdownWithGpGk.kv) },
        },
      ]
    },
    scrollbarSettings: () => scrollbarSettings,
    isFilterCompleted() {
      return this.filter.region && this.filter.period?.length === 2;
    },
  },
  watch: {
    '$apollo.loading'(pending) {
      this.$emit('change-loading', pending);
    }
  },
  methods: {
    tableItemsForm() {
      let obj = {
        name: 'Стерлибашевский МР',
        count: 30
      };
      console.log(obj)
      for (let i = 0; i<100; i++) {
        this.table.items.push({
          name: 'Стерлибашевский МР',
          count: i
        })
      }
    },
    dataLabelsFormatter:  (val) => convertIntegerToText(val),
    updateFilter(filter) {
      this.filter.region = filter.region === 'Республика Башкортостан' ? undefined : filter.region;
      this.filter.period = filter.period?.map(date => {
        const [day, month, year] = date?.split('.');
        return `${year}-${month}-${day}`;
      })
    },
    updateMapData(newData) {
      let arr = [];
      let obj = {};
      this.mapData.typename = newData.__typename;
      obj.coord = [54.74728667873139, 55.9947550905636];
      obj.totalHouses = newData.totalHouses;
      obj.totalWorks = newData.totalWorks;
      obj.worksByTypes = newData.worksByTypes;
      arr.push(obj)
      this.mapData.items = arr;
    },
  },
};
</script>

<style lang="scss">
.overhaul-placeholder {
  min-height: 300px;
}

.unit__head {
  padding: 0 10px;
  text-align: center;
}
.unit_tar {
  text-align: right;
}

.top-outages {
  display: grid;
  gap: 24px;
  margin-top: 24px;
  grid-template-columns: repeat(4, 1fr);
  @media (max-width: 1360px){
    grid-template-columns: repeat(2, 1fr);
  }
  @media (max-width: 767px) {
    grid-template-columns: repeat(1, 1fr);
  }
  &_five {
    display: grid;
    gap: 24px;
    margin-top: 24px;
    grid-template-columns: repeat(5, 1fr);
    justify-content: center;
    @media (max-width: 1360px){
      grid-template-columns: repeat(3, 1fr);
    }
    @media (max-width: 767px) {
      grid-template-columns: repeat(2, 1fr);
    }
    @media (max-width: 480px) {
      grid-template-columns: repeat(1, 1fr);
    }
  }

  &__item {
    display: flex;
    flex-direction: column;
  }
}

.grid-ventilation {
  display: grid;
  gap: 24px;
  margin-top: 24px;
  @media (min-width: 992px) {
    grid-template-columns: 66% 34%;
  }

  &__item {}
}

.item-gridVentilation {
  display: flex;
  flex-direction: column;
  gap: 24px;

  &_big {
    @media (min-width: 992px) {
      grid-column-start: 2;
      grid-column-end: 3;
      grid-row-start: 1;
      grid-row-end: 4;
    }
  }

  &__head {
    text-align: center;
    font-size: 24px;
  }

  &__body {
    .item-gridVentilation_big & {
      display: block;
    }
    display: grid;
    gap: 24px;
    max-width: 100%;
    @media (min-width: 767px) {
      grid-template-columns: 1fr 1fr;
    }
    flex: 1 1 auto;
  }
}
.leaflet-control [href="https://leafletjs.com"] {
  display: none !important;
}
</style>
<style lang="scss" module>
  .gridOutagesTable {
      grid-column-start: 1;
      grid-column-end: 3;
      grid-row-start: 1;
      grid-row-end: 2;
  }
  .gridOutagesMap {
    @media (min-width:1360px) {
      grid-column-start: 1;
      grid-column-end: 3;
      grid-row-start: 1;
      grid-row-end: 2;
    }
  }
.unit {
  padding: 18px 16px;
  border-radius: 16px;
  transition: .3s;
  max-width: 100%;
  &>div {
    display: flex;
    flex-direction: column;
    height: 100%;
    max-width: 100%;
    justify-content: center;
  }
}
.unit:hover {
  background-color: var(--v-unitHover-base) !important
}
.unit {
    background-color: var(--v-unit-base) !important;
    border-color: var(--v-unit-base) !important;
}

.wrapper {
  max-height: 700px;
}
</style>